Foreman - Bug #11885

Viewing host group clone form deletes smart class parameter overrides
09/18/2015 07:05 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Host groups
Target version: 1.10.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2756
Description

Probably since #9815, viewing the host group clone form deletes lookup_values (smart class parameter overrides) for the host group
being cloned - before the form's submitted, even.

2015-09-18T12:03:00 [app] [I] Started GET "/hostgroups/5-Testl-Test2%20Test3-Test3/clone" for 127.
0.0.1 at 2015-09-18 12:03:00 +0100

2015-09-18T12:03:00 [app] [I] Processing by HostgroupsController#clone as HTML

2015-09-18T12:03:00 [app] I[I] Parameters: {"id"=>"5-Testl-Test2 Test3-Test3"}
2015-09-18T12:03:00 [sgl] [D] User Load (0.1lms) SELECT "users".* FROM "users" WHERE "users"."id
" = 7?2 LIMIT 1 [["id", 24]]

2015-09-18T12:03:00 [app] [D] Setting current user thread-local variable to admin

2015-09-18T12:03:00 [sgl] [D] AuthSource Load (0.2ms) SELECT "auth_sources".* FROM "auth_source

s" WHERE "auth_sources"."id" = 1 LIMIT 1

2015-09-18T12:03:00 [sgl] [D] Hostgroup Load (0.3ms) SELECT "hostgroups".* FROM "hostgroups" WH

ERE "hostgroups"."title" = '5-Testl-Test2 Test3-Test3' ORDER BY hostgroups.title LIMIT 1

2015-09-18T12:03:00 [sgl] [D] Hostgroup Load (0.1lms) SELECT "hostgroups".* FROM "hostgroups" WH

ERE "hostgroups"."id" = ? ORDER BY hostgroups.title LIMIT 1 [["id", "5-Testl-Test2 Test3-Test3"]]

2015-09-18T12:03:00 [sgl] [D] ConfigGroup Load (0.3ms) SELECT "config_groups".* FROM "config_gr

oups" INNER JOIN "host_config_groups" ON "config_groups"."id" = "host_config_groups"."config_group

_id" WHERE "host_config_groups"."host_id" = 5 AND "host_config_groups"."hos

t_type" = 'Hostgroup' ORDER BY config_groups.name

2015-09-18T12:03:00 [sgl] [D] LookupValue Load (0.3ms) SELECT "lookup_values".* FROM "lookup_va

lues" WHERE "lookup_values"."match" = 'hostgroup=Testl/Test2 Test3/Test3'

2015-09-18T12:03:00 [sgl] [D] CACHE (0.0Oms) SELECT "lookup_values".* FROM "lookup_values" WHERE
"lookup_values"."match" = 'hostgroup=Testl/Test2 Test3/Test3'

2015-09-18T12:03:00 [sqgl] [D] (0.1lms) Dbegin transaction

2015-09-18T12:03:00 [sgl] [D] LookupKey Load (0.2ms) SELECT "lookup_keys".* FROM "lookup_keys"

WHERE "lookup_keys"."id" = 110 ORDER BY lookup_keys.key LIMIT 1

2015-09-18T12:03:00 [sgl] [D] LookupValue Load (0.1lms) SELECT "lookup_values".* FROM "lookup_va

lues" WHERE "lookup_values"."id" = 49 LIMIT 1

2015-09-18T12:03:00 [sgl] [D] Puppetclass Load (0.2ms) SELECT "puppetclasses".* FROM "puppetcla
sses" INNER JOIN "environment_classes" ON "puppetclasses"."id" = "environment_classes"."puppetclas
s_id" WHERE "environment_classes"."puppetclass_lookup_key_id" = 110 ORDER B

Y puppetclasses.name LIMIT 1

2015-09-18T12:03:00 [sgl] [D] (0.1ms) SELECT MAX ("audits"."version") AS max_id FROM "audits" W

HERE "audits"."auditable_id" = 49 AND "audits"."auditable_type" = 'LookupValue'

2015-09-18T12:03:00 [sgl] [E] Binary data inserted for “string’ type on column remote_address’

2015-09-18T12:03:00 [sgl] [D] SQL (0.6ms) INSERT INTO "audits" ("action", "associated_id", "ass

ociated_name", "associated_type", "auditable_id", "auditable_name", "auditable_type", "audited_cha
nges", "comment", "created_at", "remote_address", "request_uuid", "user_id"
, "user_type", "username", "version") VALUES (2, ?, ?, ?, ?, 2, 2, 2, ?, 2, 2, 2?2, 2, 2, 2, ?) re"
action", "destroy"], ["associated_id", 110], ["associated_name", "activemqg::config::server_config"
], ["associated_type", "LookupKey"], ["auditable_id", 49], ["auditable_name
", "hostgroup=Testl/Test2 Test3/Test3"], ["auditable_type", "LookupValue"], ["audited_changes", "-
——\nmatch: hostgroup=Testl/Test2 Test3/Test3\nvalue: set in three\nlookup_key_id: 110\nuse_puppet_
default: false\n"], ["comment", nil], ["created_at", Fri, 18 Sep 2015 11:03
:00 UTC +00:00], ["remote_address", "127.0.0.1"], ["request_uuid", nil], ["user_id", 24], ["user_t
ype", nil], ["username", "Admin User"], ["version", 2]]

2015-09-18T12:03:00 [sgl] [D] SQL (0.2ms) UPDATE "lookup_keys" SET "lookup_values_count" = COAL
ESCE ("lookup_values_count”, 0) - 1 WHERE "lookup_keys"."id" IN (SELECT "lookup_keys"."id" FROM "lo
okup_keys" WHERE "lookup_keys"."type" IN ('PuppetclassLookupKey') AND "look

up_keys"."id" = 110 ORDER BY lookup_keys.key)

2015-09-18T12:03:00 [sgl] [D] SQL (0.1lms) DELETE FROM "lookup_values" WHERE "lookup_values"."id
"= 7 [["id", 49]]

2015-09-18T12:03:00 [sgl] [D] LookupKey Load (0.2ms) SELECT "lookup_keys".* FROM "lookup_keys"
WHERE "lookup_keys"."id" = 114 ORDER BY lookup_keys.key LIMIT 1

2015-09-18T12:03:00 [sgl] [D] LookupValue Load (0.1lms) SELECT "lookup_values".* FROM "lookup_va
lues" WHERE "lookup_values"."id" = 50 LIMIT 1

2015-09-18T12:03:00 [sgl] [D] Puppetclass Load (0.2ms) SELECT "puppetclasses".* FROM "puppetcla
sses" INNER JOIN "environment_classes" ON "puppetclasses"."id" = "environment_classes"."puppetclas
s_1d" WHERE "environment_classes"."puppetclass_lookup_key_id" = 114 ORDER B

Y puppetclasses.name LIMIT 1

2015-09-18T12:03:00 [sgl] [D] (0.1ms) SELECT MAX ("audits"."version") AS max_id FROM "audits" W
HERE "audits"."auditable_id" = 50 AND "audits"."auditable_type" = 'LookupValue'
2015-09-18T12:03:00 [sgl] [E] Binary data inserted for “string type on column " remote_address’
2015-09-18T12:03:00 [sgl] [D] SQL (0.3ms) INSERT INTO "audits" ("action", "associated_id", "ass

ociated_name", "associated_type", "auditable_id", "auditable_name", "auditable_type", "audited_cha
nges", "comment", "created_at", "remote_address", "request_uuid", "user_id"
, "user_type", "username", "version") VALUES (?, ?, ?, ?, ?, ?, ?, 2?2, ?, 2?2, 2?2, 2, 2?2, ?, 2?2, 7?) re"
action", "destroy"], ["associated_id", 114], ["associlated_name", "activemqg::version"], ["associate
d_type", "LookupKey"], ["auditable_id", 50], ["auditable_name", "hostgroup=
Testl/Test2 Test3/Test3"], ["auditable_type", "LookupValue"], ["audited_changes", "---\nmatch: hos
tgroup=Testl/Test2 Test3/Test3\nvalue: '80'\nlookup_key_id: 1l4\nuse_puppet_default: false\n"], ["
comment", nil], ["created_at", Fri, 18 Sep 2015 11:03:00 UTC +00:00], ["rem

ote_address", "127.0.0.1"], ["request_uuid", nil], ["user_id", 24], ["user_type", nil], ["username
", "Admin User"], ["version", 2]]

2015-09-18T12:03:00 [sgl] [D] SQL (0.2ms) UPDATE "lookup_keys" SET "lookup_values_count" = COAL
ESCE ("lookup_values_count", 0) - 1 WHERE "lookup_keys"."id" IN (SELECT "lookup_keys"."id" FROM "lo
okup_keys" WHERE "lookup_keys"."type" IN ('PuppetclassLookupKey') AND "look

up_keys"."id" = 114 ORDER BY lookup_keys.key)

2015-09-18T12:03:00 [sgl] [D] SQL (0.0ms) DELETE FROM "lookup_values" WHERE "lookup_values"."id
"=7 [["id", 501]1]

2015-09-18T12:03:00 [sgl] [D] (34.9ms) commit transaction

2015-09-18T12:03:00 [sgl] [D] Puppetclass Load (0.2ms) SELECT "puppetclasses".* FROM "puppetcla
sses" INNER JOIN "hostgroup_classes" ON "puppetclasses"."id" = "hostgroup_classes"."puppetclass_id
" WHERE "hostgroup_classes"."hostgroup_id" = 5 ORDER BY puppetclasses.name

Related issues:
Related to Foreman - Bug #11425: add a real primary key to host and hostgroup... Closed 08/19/2015

Associated revisions

Revision b0eaf7{2 - 09/24/2015 05:36 AM - Dominic Cleal

fixes #11885 - exclude lookup_value_matcher on clone

Keeping lookup_value_matcher populated during a host or
hostgroup#clone caused Rails to believe the cloned object was still

associated to the existing LookupValue associated to the original
object, and it would destroy it during clone.

History

#1 - 09/23/2015 07:40 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#2 - 09/23/2015 07:52 AM - Dominic Cleal
- Related to Bug #11425: add a real primary key to host and hostgroup for lookup_values has _many added

#3 - 09/23/2015 07:56 AM - Dominic Cleal
Affects both host groups and hosts.
#4 - 09/23/2015 07:56 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2756 added
- Pull request deleted ()

#5 - 09/24/2015 06:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset b0eaf7f252b7b710751a80aafea4c03e26bfbdcc.
